package bookExamples.ch26Graphics.draw2d.shapes;

/**
 * Created by IntelliJ IDEA.
 * User: default
 * Date: Feb 10, 2005
 * Time: 7:00:34 AM
 * To change this template use File | Settings | File Templates.
 */

import bookExamples.ch26Graphics.draw2d.*;
import gui.In;
import gui.run.RunButton;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyEditor;

public class Octagon extends DJShape implements
        PropertyEditor, Intersects, Movable, Containment {
    int h = 1;
    int w = 1;
    int yc = 0;
    int xc = 0;

    double r = w / (2 * Math.sin(Math.toRadians(92)));
    double f = Math.sin(Math.toRadians(37)) /
            Math.sin(Math.toRadians(80));
    double q = w * f;

    int[] x_Points;
    int[] y_Points;

    public Octagon(int _x1, int _y1, int _x2, int _y2) {
        super(_x1, _y1, _x2, _y2);
        setX1(_x1);
        setY1(_y1);
        w = Math.abs(_x2 - getX1());
        h = Math.abs(_y2 - getY1());
        if (_x1 > _x2) setX1(_x2);
        if (_y1 > _y2) setY1(_y2);
        xc = getX1() + w / 2;
        yc = getY1() + (int) q - w / 2;
        setCenter();
    }

    private void setCenter() {
        xc = getX1() + w / 2;
        yc = getY1() + (int) q - w / 2;
    }

    public Point getCenter() {
        return new Point(xc, yc);
    }

    public DJShape getInstance(int x1, int y1, int x2, int y2) {

        return new Octagon(x1, y1, x2, y2);
        //return new Octagon (x1,y1,x2,y2);
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void draw(Graphics g) {
        //saveState(g);
        xc = getX1() + w / 2;
        yc = getY1() + (int) q - w / 2;

        // AffineTransform affineTransform = new AffineTransform();
        // affineTransform.setToRotation(90 * Math.PI / 180, xc, yc);

        double n = Math.sin(Math.toRadians(37)) /
                Math.sin(Math.toRadians(80));
        double a = w * n;

        int[] xPoints =
                {
                        (int) (getX1() + w / 2 - a / 2), (int) (getX1() + w / 2 + a / 2),
                        getX1() + w, getX1() + w, (int) (getX1() + w / 2 + a / 2),
                        (int) (getX1() + w / 2 - a / 2), getX1(), getX1()};
        x_Points = xPoints;

        int yPoints[] =
                {
                        getY1(), getY1(), (int) (getY1() - a / 2), (int) (getY1() - w + a / 2),
                        getY1() - w, getY1() - w, (int) (getY1() - w + a / 2), (int) (getY1() - a / 2)};
        y_Points = yPoints;
        //  Point pc = getCenter();
        Graphics2D g2d = (Graphics2D) g;
        AffineTransform old = g2d.getTransform();
        AffineTransform affineTransform = getAffineTransform();
        g2d.transform(affineTransform);
        g2d.setColor(getForeground());
        //  g2d.setTransform(affineTransform);
        //  affineTransform.setTransform(affineTransform);
        g2d.drawPolygon(xPoints, yPoints, 8);
        g2d.fillOval(xc, yc, 2, 2);

        g2d.drawString("(" + xc + "," + yc + ")", xc + 3, yc + 3);
        g2d.setTransform(old);
        // restoreState(g);
    }

    public String toString() {
        return "Octagon";
    }

    //  public void addPropertyChangeListener(PropertyChangeListener listener) {
    //   pcs.addPropertyChangeListener(listener);
    //  }

    ///   public void removePropertyChangeListener(PropertyChangeListener listener) {
    //   pcs.removePropertyChangeListener(listener);
    // }

    String value;
    PropertyChangeSupport pcs = new PropertyChangeSupport(this);

    public boolean isPaintable() {
        return false;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
        JPanel jp = new JPanel();
        //Container c = jd.getContentPane();
        jp.setLayout(new FlowLayout());

        jp.add(new RunButton("setForeground") {
            public void run() {
                Octagon.this.setForeground(In.getColor());
                //  pcs.firePropertyChange("Octagon",null,this);
                pcs.firePropertyChange("size", Octagon.this, null);
            }
        });
        jp.add(getRunAffinePanel());

        jp.setLayout(new FlowLayout());

        return jp;
    }

    public Object getValue() {
        return value;
    }

    public void setValue(Object newValue) {
        value = (String) newValue;
    }

    public String getAsText() {
        return null;
    }

    public String getJavaInitializationString() {
        return null;
    }

    public String[] getTags() {
        return new String[0];
        // return null;
    }

    public void setAsText(String text) throws IllegalArgumentException {
    }

    public void paintValue(Graphics gfx, Rectangle box) {
        //To change body of implemented methods use File | Settings | File Templates.
        // gfx.setClip(box);
        // gfx.drawString("click to edit...", box.x+5,box.y+15);
    }

    public Point2D getPoint(double t) {
        return new Point2D.Float(xc, yc);  //To change body of implemented methods use File | Settings | File Templates.
    }

    public Vec2d intersect(Ray2d r) {
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void move(double x, double y) {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public boolean contains(double x, double y) {
        Shape s = getShape();
        return s.contains(x, y);
    }

    public Shape getShape() {
        Point2D p1 = new Point();
        p1.setLocation((double) x_Points[0], (double) y_Points[0]);
        Point2D p2 = new Point();
        p2.setLocation((double) x_Points[1], (double) y_Points[1]);
        Point2D p3 = new Point();
        p3.setLocation((double) x_Points[2], (double) y_Points[2]);
        Point2D p4 = new Point();
        p4.setLocation((double) x_Points[3], (double) y_Points[3]);
        Point2D p5 = new Point();
        p5.setLocation((double) x_Points[4], (double) y_Points[4]);
        Point2D p6 = new Point();
        p6.setLocation((double) x_Points[5], (double) y_Points[5]);
        Point2D p7 = new Point();
        p7.setLocation((double) x_Points[6], (double) y_Points[6]);
        Point2D p8 = new Point();
        p8.setLocation((double) x_Points[7], (double) y_Points[7]);
        return getShape(p1, p2, p3, p4, p5, p6, p7, p8);
    }

    public Shape getShape(Point2D p1, Point2D p2, Point2D p3, Point2D p4,
                          Point2D p5, Point2D p6, Point2D p7, Point2D p8) {
        GeneralPath gp = new GeneralPath();
        gp.moveTo((float) p1.getX(), (float) p1.getY());
        gp.lineTo((float) p2.getX(), (float) p2.getY());
        gp.lineTo((float) p3.getX(), (float) p3.getY());
        gp.lineTo((float) p4.getX(), (float) p4.getY());
        gp.lineTo((float) p5.getX(), (float) p5.getY());
        gp.lineTo((float) p6.getX(), (float) p6.getY());
        gp.lineTo((float) p7.getX(), (float) p7.getY());
        gp.lineTo((float) p8.getX(), (float) p8.getY());
        gp.closePath();
        AffineTransform at = getAffineTransform();
        return at.createTransformedShape(gp);
    }
}









