package gui.run;

import java.util.Observable;
import java.util.Observer;
class TestMediator {
    public static void main(String args[]){
        ObservableFloat of = new ObservableFloat();
        of.setValue(100);
        TestObservableFloat tof = new TestObservableFloat();
        of.addObserver(tof);
        of.setValue(100);
        of.setValue(101);
    }
}
 class TestObservableFloat implements Observer {

     public void update(Observable o, Object arg) {
         System.out.println(o);
     }
 }

public class ObservableFloat extends Observable {

    private float value = 0;

    public synchronized void setValue(float newValue) {
        if (newValue != value) {
            value = newValue;
            super.setChanged();
            super.notifyObservers(this);
        }
    }
    public String toString(){
        return ""+value;
    }
    public synchronized float getValue() {
        return value;
    }
}