package gui.run;

import gui.ClosableJFrame;
import gui.layouts.DialogLayout;

import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public abstract class Run4SliderPanel
        extends JTabbedPane implements Runnable{

    private Quad value = new Quad();
    private SpinnerNumberModel snm[] = getSpinnerNumberModelArray();

    private SpinnerNumberModel[] getSpinnerNumberModelArray() {
        SpinnerNumberModel snm[] = new SpinnerNumberModel[4];
        for (int i = 0; i < snm.length; i++)
            snm[i] = new SpinnerNumberModel(0, -100, 100, 1);
        return snm;
    }

    public Run4SliderPanel() {
        setToolTipText("A Fine Panel!");
        addTab("getNumberModelSpinnerPanel",
                null,
                getNumberModelSpinnerPanel(),
                "getNumberModelSpinnerPanel");
    }



    private JPanel getNumberModelSpinnerPanel() {
        JPanel jp = new JPanel();

        jp.setLayout(new DialogLayout());
        for (int i = 0; i < snm.length; i++) {
            jp.add(new JLabel("v" + i));
            final int i1 = i;
            jp.add(new RunSpinnerSlider(snm[i1]) {
                public void run() {
                    int v[] = value.getValue();
                    v[i1]=getValue();
                    Run4SliderPanel.this.run();
                }
            });
        }
        return jp;
    }




    private static final int getValue(SpinnerNumberModel nm) {
        return ((Integer) nm.getValue()).intValue();
    }


    public static void main(String[] args) {
        ClosableJFrame cf = new ClosableJFrame();
        Container c = cf.getContentPane();
        c.setLayout(new FlowLayout());
        c.add(new Run4SliderPanel() {
            public void run() {
                Quad at = this.getValue();
                System.out.println(at);
            }


        });

        cf.setSize(400, 400);
        cf.setVisible(true);
    }

    public Quad getValue() {
        return value;
    }



}
