package video.broadcast;

import gui.ClosableJFrame;

import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.awt.*;
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import futils.Futil;

import javax.imageio.ImageIO;

import j2d.ImageUtils;
import j2d.ShortImageBean;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Mar 30, 2006
 * Time: 6:22:24 PM
 */
public  class ImageFrame extends ClosableJFrame {
    private BufferedImage img = null;

    public static void main(String[] args)  {
        try {
            ImageFrame IF = new ImageFrame();
            IF.setImage(getWebCamImage());
            IF.setVisible(true);
            for (int i=0; i < 1000; i++){
               IF.setImage(getWebCamImage());
                Thread.sleep(1000);
               System.out.println(i);
            }
        } catch (MalformedURLException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public static BufferedImage getWebCamImage() throws MalformedURLException {
        URL url = new URL("http://172.16.11.191/IMAGE.JPG");
        Toolkit tk = Toolkit.getDefaultToolkit();
        Image img1 = tk.getImage(url);

        do
            try {
                tk.prepareImage(img1,img1.getWidth(null),img1.getHeight(null),null);
                Thread.sleep(30);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        while ((ImageObserver.HEIGHT &tk.checkImage(img1, -1, -1, null))==0);

        Image img = new ShortImageBean(img1).getImage();
        return ImageUtils.getBufferedImage(img);
    }

    public void getImage() {
        try {
            File f = Futil.getReadFile("select an image file");
            getImage(f);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void getImage(File f) throws IOException {
        FileInputStream fis = new FileInputStream(f);
        getImage(fis);
    }

    public void getImage(InputStream is) throws IOException {
        BufferedImage bi = ImageIO.read(is);
        is.close();
        setImage(bi);
    }

    public void setImage(BufferedImage bi) {
        img = bi;
        setSize(bi.getWidth(), bi.getHeight());
        repaint();
    }

    public void paint(Graphics g) {
        if (img == null) {
            g.drawString("no data rcvd", 0, this.getHeight() / 2);
            return;
        }
        Graphics2D g2d = (Graphics2D) g;
        g2d.drawImage(img, null, 0, 0);
    }
}
